-- Compiled with roblox-ts v2.3.0-dev-576ad98
local TS = _G[script]
local _yetanothernet = TS.import(script, TS.getModule(script, "@rbxts", "yetanothernet").lib)
local Net = _yetanothernet
local Route = _yetanothernet.Route
local decoratedComponentsIn = TS.import(script, script.Parent, "utils").decoratedComponentsIn
local _constants = TS.import(script, script.Parent, "constants")
local MATTER_REPLICATION_ROUTE_NAME = _constants.MATTER_REPLICATION_ROUTE_NAME
local REPLICATED_METADATA_KEY = _constants.REPLICATED_METADATA_KEY
local _services = TS.import(script, TS.getModule(script, "@rbxts", "services"))
local Players = _services.Players
local RunService = _services.RunService
local _matter_sync = TS.import(script, TS.getModule(script, "@rbxts", "matter-sync").out)
local addSyncComponent = _matter_sync.addSyncComponent
local ClientSyncer = _matter_sync.ClientSyncer
local ServerSyncer = _matter_sync.ServerSyncer
local Object = TS.import(script, TS.getModule(script, "@rbxts", "object-utils"))
local MatterReplication
do
	MatterReplication = setmetatable({}, {
		__tostring = function()
			return "MatterReplication"
		end,
	})
	MatterReplication.__index = MatterReplication
	function MatterReplication.new(...)
		local self = setmetatable({}, MatterReplication)
		return self:constructor(...) or self
	end
	function MatterReplication:constructor(loop, world, routes, components)
		self.loop = loop
		self.world = world
		self.routes = routes
		self.components = components
		self.serverSyncer = ServerSyncer.new()
		self.replicationRoute = Route.new({
			Event = "default",
			Channel = "Reliable",
		})
		self.clientSyncer = ClientSyncer.new(self.world)
	end
	function MatterReplication:sendInitialPayload(player)
		self.replicationRoute:send(self.serverSyncer:getInitialPayload(self.world)):to(player)
	end
	function MatterReplication:setupReplication()
		self.routes[MATTER_REPLICATION_ROUTE_NAME] = self.replicationRoute
		Net.start(self.loop, self.routes)
		for _, componentCtor in Object.values(decoratedComponentsIn(self.components, REPLICATED_METADATA_KEY)) do
			addSyncComponent(componentCtor)
		end
		if RunService:IsServer() then
			self.serverSyncer:setCallback(function(payload)
				self.replicationRoute:send(payload):to(Players:GetPlayers())
			end)
			for _, player in Object.values(Players:GetPlayers()) do
				self:sendInitialPayload(player)
			end
			Players.PlayerAdded:Connect(function(player)
				self:sendInitialPayload(player)
			end)
		end
		self.loop:scheduleSystem(if RunService:IsServer() then self.serverSyncer.system else function(world)
			for _, _1, payload in self.replicationRoute:query() do
				self.clientSyncer:sync(payload)
			end
		end)
	end
end
return {
	default = MatterReplication,
}
